/****************************************************************
Interface.java
CS 481 - Team A
Written: Spring 1997
Revised: Spring 1998
Hummingbird Project - Dr. Frincke
Coded by: Pete Neisen
Revised by: Jesse C. McConnell
Description: This is a cheesy interface thrown together to display 
             hummer message forwarded to the alert interface. 
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.StringTokenizer;
import java.net.*;
import java.io.*;

public class Interface
{
  protected static NewWindow Window;
  protected static List Lst;
  protected static ButtonPanel Pnl;
  protected static Vector MessageList;
  protected static InetAddress Addr;

  protected static Button viewButton, removeButton, clearButton, quitButton;

  public static void main(String argv[])
  {
    MessageList = new Vector(10,5);
    
    try {Addr= InetAddress.getLocalHost();}
    catch(IOException E) 
        { System.err.println(E+" error");
	  System.err.println("Cannot resolve HostName."); }

    Window = new NewWindow();
    Lst = new List(10, false);
    Pnl = new ButtonPanel();

    Pnl.setLayout(new FlowLayout());

    Pnl.add(viewButton = new Button("View Message"));
    viewButton.setActionCommand("1");
    viewButton.addActionListener(Window);

    Pnl.add(removeButton = new Button("Remove Message"));
    removeButton.setActionCommand("2");
    removeButton.addActionListener(Pnl);

    Pnl.add(clearButton = new Button("Clear Messages"));
    clearButton.setActionCommand("3");
    clearButton.addActionListener(Pnl);

    Pnl.add(quitButton = new Button("Quit"));
    quitButton.setActionCommand("4");
    quitButton.addActionListener(Pnl);

    Window.setSize(400,300);
    Window.setTitle("Hummer Alert Interface - " + Addr.getHostName());
    Window.setLayout(new BorderLayout());
    Window.add("Center", Lst);
    Window.add("South", Pnl);
    Window.setVisible(true);
   
    new Server(15003); 
  }

  public static void AddToList(String NewMessageString)
  {
    Message NewMessage;
    StringTokenizer StrTok;

    NewMessage = new Message();
    StrTok = new StringTokenizer(NewMessageString, "|");

    NewMessage.Trust = StrTok.nextToken();
    NewMessage.Coop = StrTok.nextToken();
    NewMessage.Integ = StrTok.nextToken();
    NewMessage.Date = StrTok.nextToken();
    NewMessage.Time = StrTok.nextToken();
    NewMessage.Description = StrTok.nextToken();
    NewMessage.HostIP = StrTok.nextToken();
    NewMessage.Filename = StrTok.nextToken();
    NewMessage.Tool = StrTok.nextToken();
    
    MessageList.insertElementAt(NewMessage,0);
    Lst.add(NewMessage.Description,0);
    Lst.select(0);

    // This would work if we had JDK 1.1....We'll see...
    Toolkit t = java.awt.Toolkit.getDefaultToolkit();
    t.beep();
  }

}


class NewWindow extends Frame implements ActionListener
{

  public void actionPerformed(ActionEvent evt) {
 
    int Index;
    Message TempMessage;

    Index = Interface.Lst.getSelectedIndex();

    if(Index >= 0){
      TempMessage = (Message)Interface.MessageList.elementAt(Index);
      MessageFrame ViewWindow = new MessageFrame(TempMessage);	
    }
  }
}
/*
  public boolean handleEvent(Event evt)
  {
    if(evt.id == Event.ACTION_EVENT){
      int Index;
      Message TempMessage;
      
      Index = Interface.Lst.getSelectedIndex();
      TempMessage = (Message)Interface.MessageList.elementAt(Index);
      
      if(Index >= 0){
	MessageFrame ViewWindow = new MessageFrame(TempMessage);	
      }

      return true;
    }
    return false;
  }
*/  



class ButtonPanel extends Panel implements ActionListener
{
  public void actionPerformed(ActionEvent Evt)
  {
    Integer event_number = new Integer(Evt.getActionCommand());
    int Index;

    switch(event_number.intValue()) {

//    case 1:

/* This is some of the former code.  It is not needed now that the 
   Message object is registered as an ActionListener.
   
   This case statement is not needed as this class is no longer interested
   in the view event...

      Message TempMessage;
      
      Index = Interface.Lst.getSelectedIndex();
      if(Index >= 0){
	TempMessage = (Message)Interface.MessageList.elementAt(Index);
	MessageFrame ViewWindow = new MessageFrame(TempMessage);
      }
*/
//      break;
    case 2:
      Index = Interface.Lst.getSelectedIndex();
      if(Index >= 0){
	Interface.Lst.remove(Index);
	Interface.MessageList.removeElementAt(Index);
	Interface.MessageList.trimToSize();
	Interface.Lst.select(0);
      }
      break;
    case 3:
      int EndIndex;
      EndIndex=Interface.Lst.getItemCount();
      
      /*for (Index=0; Index < EndIndex; Index=Index +1) { 
	Interface.Lst.remove(0);
	Interface.MessageList.removeElementAt(0);
	Interface.MessageList.trimToSize();
	Interface.Lst.select(0);
      }*/
      
      if (EndIndex > 0) {
	Interface.Lst.removeAll();
	Interface.MessageList.removeAllElements();
      }

      break;
    case 4:
      System.exit(0); 
    }
  }
}
/*

    if(Evt.target instanceof Button){
      String Label = (String)Arg;
      if(Label.equals("Quit")){
	System.exit(0);
	return true;
      }

      if(Label.equals("View Message")){
	int Index;
	Message TempMessage;

	Index = Interface.Lst.getSelectedIndex();
	if(Index >= 0){
	  TempMessage = (Message)Interface.MessageList.elementAt(Index);
	  MessageFrame ViewWindow = new MessageFrame(TempMessage);
	}
	return true;
      }

      if(Label.equals("Remove Message")){
	int Index;

	Index = Interface.Lst.getSelectedIndex();
	if(Index >= 0){
	  Interface.Lst.delItem(Index);
	  Interface.MessageList.removeElementAt(Index);
	  Interface.MessageList.trimToSize();
	  Interface.Lst.select(0);
	}
	return true;
      }

      if(Label.equals("Clear Messages")){
	int Index, EndIndex;
	EndIndex=Interface.Lst.countItems();

	for (Index=0; Index < EndIndex; Index=Index +1) { 
	     Interface.Lst.delItem(0);
	     Interface.MessageList.removeElementAt(0);
	     Interface.MessageList.trimToSize();
	     Interface.Lst.select(0);
	}
	return true;
      }
   }
    return false;
  }
*/



class MessageFrame extends Frame implements ActionListener
{
  private Button Close;

  public MessageFrame(Message NewMessage)
  {
    
    super(NewMessage.Description);

    String str;
    TextArea Txtarea;
    setSize(450,200);
    Close = new Button("Close");
    Close.setActionCommand("1");
    Close.addActionListener(this);
    add("South",Close);

    str = "Description: "+NewMessage.Description+
      "\nTrust Level: "+NewMessage.Trust+
      "\nCooperation Level: "+NewMessage.Coop+
      "\nIntegrity Level: "+NewMessage.Integ+
      "\nDate: "+
      NewMessage.Date.substring(4,6)+"/"+
      NewMessage.Date.substring(6,NewMessage.Date.length())+"/"+
      NewMessage.Date.substring(0,4)+
      "\nTime: "+
      NewMessage.Time.substring(0,2)+":"+
      NewMessage.Time.substring(2,4)+":"+
      NewMessage.Time.substring(4,6)+
      "\nOriginating Host: "+NewMessage.HostIP+
      "\nFilename: "+NewMessage.Filename+
      "\nTool: "+NewMessage.Tool+"\n";
    Txtarea = new TextArea(str,325,175);
    Txtarea.setBackground(Color.gray);
    add("Center", Txtarea); 
    
    this.setVisible(true);
  }

  public void actionPerformed(ActionEvent evt) {
    
    if((evt.getActionCommand()).equals("1")) {
      this.setVisible(false);
      this.dispose();
    }
  }
}

class Message extends Object
{
  public String Trust;
  public String Coop;
  public String Integ;
  public String Date;
  public String Time;
  public String Description;
  public String HostIP;
  public String Filename;
  public String Tool;
}
