/****************************************************************
MessageFilterCon.h
CS 481 - Team A
Spring 1997
Hummingbird Project - Dr. Frincke
Coded by: Pete Neisen
Description: This is the class definition of the message filter container
             object. It stores and handles the message filter objects. It
	     also handles the regualr expression matching of the filters
	     to a message.
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _MessageFilterCon_h
#define _MessageFilterCon_h

#include "Hummer.h"          // Global hummer defines.
#include "MessageFilter.h"   // Message filter object.
#include <stdlib.h>
extern "C" {
#include <regex.h>
}

class MessageFilterCon
{
// Data
private:
  MessageFilter *Head;
  MessageFilter *Last;

// Methods
private:
  int Match(char *String, char *Pattern);

public:
  MessageFilterCon();
  ~MessageFilterCon();
  int AddFilter(MessageFilter *NewFilter);
  MessageFilter *MatchExp(char *Message);
};
  

#endif
