/****************************************************************
MessageHandler.h
CS 481 - Team A
Spring 1997
Hummingbird Project - Dr. Frincke
Coded by: Pete Neisen
Description: This is the class definition for the message handler object.
             The message handler is the main message processing object of
	     the hummer. It matches messages with filters and then uses
	     the filter to process the message.
*****************************************************************/
/*
  Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _MessageHandler_h
#define _MessageHandler_h

#include "Hummer.h"              // Global hummer defines
#include "Message.h"             // Message object
#include "MessageFilterCon.h"    // Message filter container
#include "LevelCon.h"            // Trust object container
#include "Print_Error.h"         // Print_Error function
#include "sock_cli.h"
#include "ConvertIP.h"           // IP conversion function
#include "datetime.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
//#include <time.h>
#ifdef POSTGRES
#include <Hummer_PG.h>
#endif
#include <iostream.h>

class MessageHandler
{
// Data
private:
  MessageFilterCon Filters;
  LevelCon Levels;
  HostList *Kills;

// Methods
private:
  char *GetManager(void);
  int GetSubord(HostList **Subord);
  int LoadMessageFilters(void);
  int LoadLevel(void);
  int LoadKills(void);
  int InKills(char *HostIP);

public:
 
  MessageHandler();
  ~MessageHandler();
  int HandleMessage(Message *NewMessage, char *HostIP);
  int LoadConfigFiles(void);
  void ReportError(char *ErrMessage);
};
  

#endif
