/****************************************************************
Server.h
CS 481 - Team A
Spring 1997
Hummingbird Project - Dr. Frincke
Coded by: Pete Neisen
Description: This file contains the class definition for the Server Object.
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _Server_h
#define _Server_h

#include "Hummer.h"         // Global hummer defines
#include "sock_serv.h"
#include "sock_cli.h"
#include "MessageHandler.h" // The hummer message handler
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>


class Server
{
  // Data;
 private:
  sock_serv *InSocket;
  sock_cli *ConnectedSocket;
  MessageHandler *ServerMessageHandler; 
  int Port;
  int ServerRun;           
  int ReloadHandler;

// Methods

private:
  void ProcessRequest(void);

public:
  Server();
  Server(int NewPort);
  ~Server();
  void StartServer(void);
  void KillServer(void);
  void LoadHandler(void);
  void SetReloadHandler(void);
};
  

#endif
