#! &PERL& -I&INCDIR&
# -*- perl -*-
# must include the above line to use perl v5.002 on this system

 ##############################################################
 #      Hummingbird  (Team A)
 #      05/29/97
 #      Dean Polla
 #      
 #  This tool is designed to parse the access.log and send all
 #  relevant information to its hummer.
 ##############################################################

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use Toollib;

forktoBg($0);      
$logfile = "/usr/local/etc/httpd/logs/access_log";

&parseData();

&delpid();

#################################################################
# This subroutine will parse the information in the log file
# and call 'ToolI'
#################################################################

sub parseData {
    open (LOG,$logfile) || die "Can't open $logfile.\n";
    
    # Seeks to the end of the file and clears the end of file pointer
    seek LOG,0,2;
    seek LOG,0,1;
    
    while (!$do_exit) { 
	while (<LOG>) {
	    chop;		
	    
	    # The information is stored as: 
	    # <who is accessing> - - [Date:time -800] "GET <what accessed> HTTP/1.0" num num
	    # Fields are delineated by whitespace.  
	    # We seperate the fields and place them in the designated vars.
	    
	    ($addr,$g1,$g2,$date,$g3,$g4,$image,$meth,$g6,$g7)= split(/ +/,$_);
	    
	    #it is necessary to split up the date so we can reformat the 
            #information 
	    ($dd,$month,$temp) = split('/',$date);
	    
	    #it is necessary to split up the date so we can reformat the 
            #information
	    ($yyyy,$hh,$mm,$ss) = split(/:/,$temp);
	    
	    #kills the following chars seperates out the day
	    $dd = substr($dd,-2);
	    
	    #it is necessary to have the month in number format for the hummer
	    $month = atoiMonth($month);
	    
	    #joins the year(yyyy), month, and day without spaces : date stamp
	    $date = join('', $yyyy,$month,$dd);
	    
	    #joins the hours, minutes, and days without spaces : time stamp
	    $time = join('',$hh,$mm,$ss);
	    
	    #removes the trailing "
	    $meth =~ s/"//;
	    
	    #sets up the message to be sent to the hummer
	    $msngr = join(' ', $addr,accessed,$image,with,$meth);

	    ToolI($msngr, $date, $time, $hostname, $logfile, "acstool");
	}
	
	#reads to end of the file, waits for new info to arrive, 
	#then removes the end of file marker and tries to read again
	sleep $sleepTime;
	seek LOG,0,1;
    }
    close(LOG);
}
