/****************************************************************
datetime.C
CS 481 - Team E
Spring 1998
Hummingbird Project - Dr. Frincke
Coded by: Jamie Marconi
Description:  This files contains the basic functions that convert
             between the two of our date and time formats.
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

static char datetime_C[] = "$Id: datetime.C,v 1.2 1998/03/06 23:00:17 marc9442 Exp $";

#include "datetime.h"

/**********
Function: makedate
Purpose:  This function takes a date string of the form YYYYMMDD and formats
          it as MM-DD-YYYY. Returned values memory must be deleted when 
	  finished.  
**********/

char *makedate(char* d)
{
  // create space
  char *newdate;
  newdate = new char[11];

  // form date
  sprintf(newdate, "%c%c-%c%c-%c%c%c%c", 
	  d[4], d[5], d[6], d[7], d[0], d[1], d[2], d[3]);

  return newdate;
}

/**********
Function: maketime
Purpose:  This function takes a time string of the form HHMMSS and formats it
          as HH:MM:SS. Returned values memory must be deleted when finished.
**********/

char *maketime(char *t)
{
  // create space
  char *newtime;
  newtime = new char[10];

  // form time
  sprintf(newtime, "%c%c:%c%c:%c%c",
          t[0], t[1], t[2], t[3], t[4], t[5]);

  return newtime;
}

/**********
Function: unmakedate
Purpose:  This function takes a date string of the form MM-DD-YYYY and formats
          it as YYYYMMDD. Returned values memory must be deleted when 
	  finished.  
**********/

char *unmakedate(char* d)
{
  // create space
  char *newdate;
  newdate = new char[9];

  // form date
  sprintf(newdate, "%c%c%c%c%c%c%c%c", 
	  d[6], d[7], d[8], d[9], d[0], d[1], d[3], d[4]);

  return newdate;
}

/**********
Function: unmaketime
Purpose:  This function takes a time string of the form HH:MM:SS and formats it
          as HHMMSS. Returned values memory must be deleted when finished.
**********/

char *unmaketime(char *t)
{
  // create space
  char *newtime;
  newtime = new char[7];

  // form time
  sprintf(newtime, "%c%c%c%c%c%c",
          t[0], t[1], t[3], t[4], t[6], t[7]);

  return newtime;
}
