#! &PERL& -I&INCDIR&
# -*- perl -*-
#must include this line to use perl v5.002 on this system.

 ##############################################################
 #      Hummingbird  (Team A)
 #      05/29/97
 #      Dean Polla
 #
 #  This tool is designed to parse the mail.log and send all
 #  relevant information to its hummer.  
 #
 ##############################################################

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

 use Toollib;
 use Datelib qw($year);

 forktoBg($0);
 $logfile   =   "&MAILLOG&";
 &parseData();
 &delpid();


#################################################################
# This subroutine will parse the information in the log file
# and call 'ToolI'
#################################################################

sub parseData {
  open (LOG,$logfile) || die "Can't open $logfile.\n";

  # Seeks to the end of the file and clears the end of file pointer
  seek LOG,0,2;
  seek LOG,0,1;
 
while (!$do_exit) {
  while (<LOG>) { 
   chop;                

   # fields are delineated by whitespace.  Here, we seperate the fields.
   # The info is stored as month day time host function[number] mailinfo
   # Here, the function and mail info are placed in an array.
   ($month,$dd,$time,$site,@msg) = split(/ +/,$_);

   if ($dd < 10) { $dd = "0". $dd; }
   
   #it is necessary to have the month in number format for the hummer   
   $month = atoiMonth($month);

   #forms the date stamp
   $date = join('', $year,$month,$dd);

   #remove the ':' from the time stamp
   $time =~ s/://g;
 
   # the message is simply the function followed by the mail info.
   # mail info should appear just as it did in the log
   $msngr = join (' ', @msg);
        
   ToolI($msngr, $date, $time, $hostname, $logfile, "mailtool");        
  }
                
    #reads to end of the file, waits 15 sec for new info to arrive, 
    #then removes the end of file marker.
     sleep $sleepTime;
     seek LOG,0,1;
}
close(LOG);
}
