#! &PERL&

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#

use CGI qw(:standard);
use Pg;
use strict;

use Sys::Hostname;
my $host = hostname();

my $conn = Pg::connectdb("dbname = hummer_$host");
( PGRES_CONNECTION_OK eq $conn->status ) || exit;
my $result;
my $inh = param('inh');


print header;
print start_html(-title=>'Messaging Configuration',
		 -TEXT=>'black', 
		 -BGCOLOR=>'white',
		 -LINK=>'blue',
		 -VLINK=>'purple');
print "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
    h1('Messaging Configuration');


if ($inh eq "") {
  print h2('Error: Must specify inherited value');
}
else {
  if (!param('Action')) {
    $result = $conn->exec("select * from filter where inh = $inh;");
    (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
    
    my @filters;
    my $i;
    for ($i=0; $i < $result->ntuples; $i++) {
      $filters[$i] = $result->getvalue($i, $result->fnumber("expression"));
  }
    print  "<H3><A HREF=\"messconfhelp.html\">Help</A></H3>",
    "<H4><A HREF=\"filters.shtml\">Return to Message Configuration Page</A></H4>",hr,
    "</center>";
    print "<center>",
    start_form,
    hidden(-name=>'inh',-default=>["$inh"]),
    h2('Current Expressions Available for Modification'),
    "Select an expression and an action",
    popup_menu(-name=>'mess',
	       -values=> [ @filters ]),
    br,br;
    
    print "<TABLE border=0 cellpadding=10>",
    "<TR><TD><INPUT type=radio name=messcfg value=messmod>",
    "Modify Selected Expression</TD></TR>",
    "<TR><TD><INPUT type=radio name=messcfg value=messrem>",
    "Remove the Selected Expression</TD></TR>",
    "<TR><TD><a href=\"addfilter.cgi?inh=$inh\">Add a New Expression</a></TD></TR>",
    "</TABLE>",
    
    submit('Action','Configure'),
    reset(),
    button(-value=>'Cancel',
	   -onclick=>"history.back()"),
    end_form,
    "</center>";
  }
  else {
    &Mod_or_Rem();
  }
}

print end_html;


sub Mod_or_Rem {
  
  my $filter = param('mess');
  my $messcfg = param('messcfg');
  
  if ($messcfg eq "messrem") {
    if ($filter eq "")
    {
       	print "<BR><BR><H2>There was no expression chosen...</H2>\n"; 
    }

    else
    {  
      $result = $conn->exec("delete from filter where expression = '$filter' and inh = $inh;");
      (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
      $result = $conn->exec("delete from forward_list where filter = '$filter' and inh = $inh;");
      (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
      $result = $conn->exec("delete from accept_list where filter = '$filter' and inh = $inh;");
      (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
      $result = $conn->exec("delete from forward_peer where filter = '$filter' and inh = $inh;");
      (PGRES_COMMAND_OK eq $result->resultStatus) || exit;

      print h2("Filter $filter Removed"),br;
    }
  }

 if ($messcfg eq "messmod") {
    if ($filter eq "")
    {
       	print "<BR><BR><H2>There was no expression chosen...</H2>\n"; 
    }

    else
    {  
      print  "<H3><A HREF=\"filterhelp.html\">Help</A></H3>", 
      "<H4><A HREF=\"filters.shtml\">Return to Message Configuration Page</A></H4>",hr,
      "</center>";

      my $result = $conn->exec("select * from filter where expression = '$filter' and inh = $inh;");
      my $expression = $result->getvalue(0,$result->fnumber("expression"));
      my $start_date = $result->getvalue(0,$result->fnumber("date_start"));
      my $end_date = $result->getvalue(0,$result->fnumber("date_end"));
      my $start_time = $result->getvalue(0,$result->fnumber("time_start"));
      my $end_time = $result->getvalue(0,$result->fnumber("time_end"));
      my $trust = $result->getvalue(0,$result->fnumber("trust"));
      my $coop = $result->getvalue(0,$result->fnumber("coop"));
      my $integ = $result->getvalue(0,$result->fnumber("integ"));
      my $alert = $result->getvalue(0,$result->fnumber("alert"));
      if ($alert) { $alert = "checked"; } else { $alert = ""; }
      my $log = $result->getvalue(0,$result->fnumber("log"));
      if ($log) { $log = "checked"; } else { $log = ""; }

      print "<center><FORM ACTION=\"/addfilter.cgi\" METHOD=POST>",
      hidden(-name=>'inh',-default=>["$inh"]),
      "<H2>Modify Filter</H2>",
      "<H4>Regular Expression:<INPUT type=text name=regexp size=30 value=$expression></h4>",
      hr,
      "<table border=0 cellpadding=10>",
      "<tr><td>",
      "<H3>Filters</H3>",
      hr,
      "Date  MM-DD-YYYY<BR><BR>",
      "Begin:<INPUT type=text name=date1 size=10 value=$start_date>",
      "End:<INPUT type=text name=date2 size=10 value=$end_date><BR><BR>",
      "Time HH:MM:SS<BR><BR>",
      "Begin:<INPUT type=text name=time1 size=8 value=$start_time>",
      "End:<INPUT type=text name=time2 size=8 value=$end_time><BR><BR>",
      
      "Trust Level: ", popup_menu(-name=>'trust',
				-values=> [ 'NULL', '1', '2', '3', '4', '5' ],
				-default=>"$trust",
				-override=>1
			       ),br,

      "Cooperation Level: ", popup_menu(-name=>'coop',
				      -values=> [ 'NULL', '1' , '2', '3', '4', '5' ],
				      -default=>"$coop",
				      -override=>1
				     ),br,
    
      "Integrity Level: ", popup_menu(-name=>'integ',
				    -values=> [ 'NULL', '1' , '2', '3', '4', '5' ],
				    -default=>"$integ",
				    -override=>1
				   ),br,
      "Messages accepted from:<BR><BR>";

      $result = $conn->exec("select * from accept_list where filter = '$filter' and inh = $inh;");
      print "<TEXTAREA name=accept rows=5 cols=35>";
      my $i;
      for ($i=0; $i < $result->ntuples; $i++) {
        my $start;
        my $end;
        $start = $result->getvalue($i, $result->fnumber("start_addr"));
        $end = $result->getvalue($i, $result->fnumber("end_addr"));
        if ($end eq "") {
	  print "$start\n";
        }
        else {
	  print "$start-$end\n";
        }
      }
    
      print "</TEXTAREA>";
    
      print "</td><td><H3>Actions and Alerts</h3>",
      hr,
      "<INPUT type=checkbox name=local $log>Log Locally<BR><BR>",
      "<INPUT type=checkbox name=alert $alert>Alert this Console<BR><BR>",
      "Forward this message to the Hummers:<BR><BR>";
    
      $result = $conn->exec("select * from forward_list where filter = '$filter' and inh = $inh;");

      print "<TEXTAREA name=forwards rows=5 cols=35>";
      for ($i=0; $i < $result->ntuples; $i++) {
        print $result->getvalue($i, $result->fnumber("host")), "\n";
      }
      print "</TEXTAREA>",br,br;

      $result = $conn->exec("select * from pgroups;");
      (PGRES_TUPLES_OK eq $result->resultStatus) || exit;

      my @groupnames;
      for (my $i=0; $i < $result->ntuples; $i++) {
        $groupnames[$i] = $result->getvalue($i,0);
      }
    
      my @forward_peer;
      $result = $conn->exec("select * from forward_peer where filter = '$filter' and inh = $inh;");
      for (my $i=0; $i < $result->ntuples; $i++) {
        $forward_peer[$i] = $result->getvalue($i,1);
      }
    
      (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
   
      print "Forward this message to the Peer Groups:",br,br,
    
      scrolling_list(-name=>'forward_peer',
		   -values=>[ @groupnames ],
		   -default=>[ @forward_peer ],
		   -size=>5,
		   -multiple=>'true');
    
      print "</td></tr></table>",
      hr,
      submit('Action','Configure'),
      reset(),
      button(-value=>'Cancel',
	   -onclick=>"history.back()"),
      end_form,
      "</center>\n";
    }
  }

#  else 
#  {
    #	print "<center><BR><BR><H2>There was no action chosen...</H2>\n</center>"; 
#  }

}
  







