/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <config.h>

#include "sock_serv.h"
#include "sock_cli.h"

#include <sys/wait.h>
#include <iostream.h>

main()
{
  signal(SIGCHLD, SIG_IGN);
  sock_serv *InSocket;
  InSocket = new sock_serv();

  InSocket->create();
  char *service = "simple";
  if (!InSocket->bind(15005, service)) {
    fprintf (stderr, "Socket Bind Error.  Is the server already running.\n");
    exit(1);
  }
  InSocket->listen(SOMAXCONN);

  while (1) {
    if (InSocket->accept()) {
      sock_cli *OutSocket = InSocket->make_sock_cli();
      
      if (fork() == 0) {
	InSocket->close();
	delete InSocket;
	if (OutSocket->recv_auth("./krb5_sock_test_serv.keytab")) {
	  char *buf;
	  buf = new char[1024];
	  do {
	    OutSocket->read(buf, 1024);
	    cout << buf << endl;
	    
	  } while (buf[0] != 'E');
	  OutSocket->read(buf, 1024);
	  cout << buf << endl;
	  OutSocket->write("I am server hear me squeek.\n");
	  
	}
	OutSocket->close();
	delete OutSocket;
	exit(0);
      }
      
      else {
	OutSocket->close();
      }
    }
  }

  InSocket->close();
  delete InSocket;

  return 0;
}


