#! &PERL& -I&INCDIR&
# -*- perl -*-
#must include this line to use perl v5.002 on this system.

 ##############################################################
 #      Hummingbird  (Team A)
 #      05/30/97
 #      Dean Polla
 #
 #  This tool is designed to parse the switch user log file and 
 #  send all the relevant information to its hummer.
 #
 #  NOTE:  This log file is not currently being accumulated by
 #         the system administrator.
 #
 ##############################################################

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use Toollib;
use Datelib qw($year $second);

forktoBg($0);
$logfile = "/net/dworshak1/classes/sulog.old";
 
 $badsu = "Bad switch user attempt";
 $check = "-";

&parseData();
&delpid();


#################################################################
# This subroutine will parse the information in the log file
# and call 'ToolI'   
#################################################################
   
sub parseData {
 open (LOG,$logfile) || die "Can't open $logfile.\n";
   
 # Seeks to the end of the file and clears the end of file pointer
 seek LOG,0,2;
 seek LOG,0,1;

 
while (!$do_exit) {
  while (<LOG>) {
   chop;                # removes the end of line marker from the string

   #the information is stored as: 
   #SU <date> <time> <success> tty** <access from-by>
   ($label,$date,$time,$success,$device,$from_to) = split(/ /,$_);

   #if the success field indicates a failure to open the account
   if ($success eq $check) {
      #splits up the date stamp, adds the 0's for the year, and joins them all together.
      ($mm,$dd) = split('/',$date);
      $yyyymmdd = join('', $year,$mm,$dd);
                
      #removes the ':' from the time stamp
      $time =~ s/://g;

      #joins the year, minutes, and seconds into the time stamp
      $hhmmss = join('', $time,$second);
                
      #forms the bad switch user attempt message going to the hummer
      $msngr = join (' ', $badsu,$from_to);
                        
  
      ToolI($msngr, $yyyymmdd, $hhmmss, $hostname, $logfile, "sutool");
    } #if
  }
      #reads to end of the file, waits 15 sec for new info to arrive, 
      #then removes the end of file marker and tries to read again
        sleep $sleepTime;       
        seek LOG,0,1;
}
close(LOG);
}
